;Light Doorscan version 1.0
;Author: ENNE
;For info: lds@enne.skystorm.net
;Warning: don't modify and ripping this code please
menu menubar {
  Light Doorscan:lightdoorscan
}
dialog lightdoorscan {
  title "Light Doorscan - ENNE <lds@enne.skystorm.net>"
  size -1 -1 178 122
  option dbu
  box "Door's range", 1, 2 2 86 32
  text "Start door:", 2, 5 13 27 8
  text "End door:", 3, 5 23 27 8
  edit "", 4, 32 11 22 10, limit 5
  edit "", 5, 32 21 22 10, limit 5
  button "start scan", 6, 55 12 31 18, flat
  box "Open doors detected", 7, 2 36 86 85
  list 8, 5 46 80 62, size
  box "Status", 9, 89 2 87 32
  text "Ready to scan...", 10, 93 17 79 8
  button "save results", 11, 5 110 79 10, flat
  box "Telnet socks", 12, 89 36 87 73
  text "Double click on a door to open connection...", 13, 93 44 55 14
  edit "", 14, 92 58 81 50, read multi hsbar vsbar
  button "close light doorscan", 15, 89 110 87 10, flat
}
on *:dialog:lightdoorscan:sclick:11: {
  unset %lds.file
  set %lds.file $?="Insert the file name (example: scan.txt):"
  if (%lds.file = $null) { did -a lightdoorscan 10 Error: no file name insert | halt }
  unset %lds.read
  write %lds.file --------------------------------
  write %lds.file Light Doorscan - session results
  :lds_read
  inc %lds.read
  if (%lds.read > $did(lightdoorscan,8).lines) { did -a lightdoorscan 10 Results saved in %lds.file | halt }
  write %lds.file $did(lightdoorscan,8,%lds.read).text
  goto lds_read
}
on *:dialog:lightdoorscan:sclick:15: {
  unset %lds.*
  sockclose lds*
  dialog -x lightdoorscan
}
on *:dialog:lightdoorscan:dclick:8: {
  inc %lds.socks
  sockopen lds $+ %lds.socks 127.0.0.1 $did(lightdoorscan,8).seltext
  did -a lightdoorscan 10 Open sock localhost: $+ $did(lightdoorscan,8).seltext
}
on *:SOCKREAD:lds*: {
  sockread %lds.sread
  if (%lds.sread = $null) { halt }
  if ($dialog(lightdoorscan) = lightdoorscan) {
    inc %lds.sread.tmp
    did -i lightdoorscan 14 %lds.sread.tmp ( $+ $sock($sockname).port $+ ) %lds.sread
  }
}
on *:dialog:lightdoorscan:close:0: { unset %lds.* | sockclose lds* }
alias lightdoorscan {
  sockclose lds*
  unset %lds.*
  if ($dialog(lightdoorscan) = lightdoorscan) { dialog -x lightdoorscan }
  if (($1 != $null) && ($2 != $null)) { set %lds.start $1 | set %lds.end $2 }
  dialog -mr lightdoorscan lightdoorscan
}
on *:dialog:lightdoorscan:init:0: {
  if ((%lds.start != $null) && (%lds.end != $null)) {
    did -a lightdoorscan 4 %lds.start
    did -a lightdoorscan 5 %lds.end
    if ($did(lightdoorscan,5) < $did(lightdoorscan,4)) { did -a lightdoorscan 10 Error: end door < start door | halt  }
    did -m lightdoorscan 4
    did -m lightdoorscan 5 
    did -b lightdoorscan 6
    did -b lightdoorscan 15
    did -b lightdoorscan 11
    did -r lightdoorscan 8
    unset %lds.result
    inc %lds.result
    did -i lightdoorscan 8 %lds.result Scan from $did(lightdoorscan,4) to $did(lightdoorscan,5)
    inc %lds.result
    did -i lightdoorscan 8 %lds.result Start: $date $time
    inc %lds.result
    did -i lightdoorscan 8 %lds.result $null
    unset %lds.ports
    unset %lds.scans*
    set %lds.start $did(lightdoorscan,4)
    set %lds.ports %lds.start - 1
    set %lds.end $did(lightdoorscan,5)
    set %lds.scans %lds.end - %lds.start 
    inc %lds.scans
    :lds
    inc %lds.scans3
    inc %lds.ports
    if (%lds.ports > %lds.end) {
      did -a lightdoorscan 10 Scan session terminated $int(%lds.scans2) $+ %
      inc %lds.result
      did -i lightdoorscan 8 %lds.result $null
      inc %lds.result
      did -i lightdoorscan 8 %lds.result End scan: $date $time
      did -n lightdoorscan 4
      did -n lightdoorscan 5 
      did -e lightdoorscan 6
      did -e lightdoorscan 15
      did -e lightdoorscan 11
      halt 
    }
    if ($portfree(%lds.ports) = $false) { 
      inc %lds.result 
      did -i lightdoorscan 8 %lds.result %lds.ports
      if (%lds.ports = 21) { did -o lightdoorscan 8 %lds.result %lds.ports (FTP) }
      if (%lds.ports = 139) { did -o lightdoorscan 8 %lds.result %lds.ports (NetBios) }
      if (%lds.ports = 25) { did -o lightdoorscan 8 %lds.result %lds.ports (SMTP) }
      if (%lds.ports = 110) { did -o lightdoorscan 8 %lds.result %lds.ports (POP) }
      if (%lds.ports = 6667) { did -o lightdoorscan 8 %lds.result %lds.ports (IRC) }
      if (%lds.ports = 21) { did -o lightdoorscan 8 %lds.result %lds.ports (FTP) }
      if (%lds.ports = 12345) { did -o lightdoorscan 8 %lds.result %lds.ports (WARNING trojan NetBus) }
      if (%lds.ports = 143) { did -o lightdoorscan 8 %lds.result %lds.ports (IMAP) }
      if (%lds.ports = 22) { did -o lightdoorscan 8 %lds.result %lds.ports (SSH) }
      if (%lds.ports = 23) { did -o lightdoorscan 8 %lds.result %lds.ports (Telnet) }
      if (%lds.ports = 80) { did -o lightdoorscan 8 %lds.result %lds.ports (HTTP) }
      if (%lds.ports = 443) { did -o lightdoorscan 8 %lds.result %lds.ports (SSL) }
    }
    set %lds.scans2 %lds.scans3 / %lds.scans 
    set %lds.scans2 %lds.scans2 * 100
    did -a lightdoorscan 10 Scan port %lds.ports ( $+ $int(%lds.scans2) $+ % $+ ) waiting
    goto lds

  }
}
on *:dialog:lightdoorscan:sclick:6: {
  if (($did(lightdoorscan,4) = $null) && ($did(lightdoorscan,5) = $null)) { did -a lightdoorscan 10 Error: insert start and end door | halt }
  if ($did(lightdoorscan,4) = $null) { did -a lightdoorscan 10 Error: insert start door | halt }
  if ($did(lightdoorscan,5) = $null) { did -a lightdoorscan 10 Error: inser end door | halt  }
  if ($did(lightdoorscan,5) < $did(lightdoorscan,4)) { did -a lightdoorscan 10 Error: end door < start door | halt  }
  did -m lightdoorscan 4
  did -m lightdoorscan 5 
  did -b lightdoorscan 6
  did -b lightdoorscan 15
  did -b lightdoorscan 11
  did -r lightdoorscan 8
  unset %lds.result
  inc %lds.result
  did -i lightdoorscan 8 %lds.result Scan from $did(lightdoorscan,4) to $did(lightdoorscan,5)
  inc %lds.result
  did -i lightdoorscan 8 %lds.result Start: $date $time
  inc %lds.result
  did -i lightdoorscan 8 %lds.result $null
  unset %lds.ports
  unset %lds.scans*
  set %lds.start $did(lightdoorscan,4)
  set %lds.ports %lds.start - 1
  set %lds.end $did(lightdoorscan,5)
  set %lds.scans %lds.end - %lds.start 
  inc %lds.scans
  :lds
  inc %lds.scans3
  inc %lds.ports
  if (%lds.ports > %lds.end) {
    did -a lightdoorscan 10 Scan session terminated $int(%lds.scans2) $+ %
    inc %lds.result
    did -i lightdoorscan 8 %lds.result $null
    inc %lds.result
    did -i lightdoorscan 8 %lds.result End scan: $date $time
    did -n lightdoorscan 4
    did -n lightdoorscan 5 
    did -e lightdoorscan 6
    did -e lightdoorscan 15
    did -e lightdoorscan 11
    halt 
  }
  if ($portfree(%lds.ports) = $false) { 
    inc %lds.result 
    did -i lightdoorscan 8 %lds.result %lds.ports
    if (%lds.ports = 21) { did -o lightdoorscan 8 %lds.result %lds.ports (FTP) }
    if (%lds.ports = 139) { did -o lightdoorscan 8 %lds.result %lds.ports (NetBios) }
    if (%lds.ports = 25) { did -o lightdoorscan 8 %lds.result %lds.ports (SMTP) }
    if (%lds.ports = 110) { did -o lightdoorscan 8 %lds.result %lds.ports (POP) }
    if (%lds.ports = 6667) { did -o lightdoorscan 8 %lds.result %lds.ports (IRC) }
    if (%lds.ports = 21) { did -o lightdoorscan 8 %lds.result %lds.ports (FTP) }
    if (%lds.ports = 12345) { did -o lightdoorscan 8 %lds.result %lds.ports (WARNING trojan NetBus) }
    if (%lds.ports = 143) { did -o lightdoorscan 8 %lds.result %lds.ports (IMAP) }
    if (%lds.ports = 22) { did -o lightdoorscan 8 %lds.result %lds.ports (SSH) }
    if (%lds.ports = 23) { did -o lightdoorscan 8 %lds.result %lds.ports (Telnet) }
    if (%lds.ports = 80) { did -o lightdoorscan 8 %lds.result %lds.ports (HTTP) }
    if (%lds.ports = 443) { did -o lightdoorscan 8 %lds.result %lds.ports (SSL) }
  }
  set %lds.scans2 %lds.scans3 / %lds.scans 
  set %lds.scans2 %lds.scans2 * 100
  did -a lightdoorscan 10 Scan port %lds.ports ( $+ $int(%lds.scans2) $+ % $+ ) waiting
  goto lds
}
